{
  Ship Viewer
}
{$A+,B-,D+,E+,F-,G+,I-,L+,N-,O+,R-,S+,V-,X+}
{$M 16384,0,655360}
USES FixedCRT,Cursor;

CONST Copyrite='Ships viewer for VGA Planets(tm) - (c) copyright 1995,1998,2003 by Streu';

CONST NUM_SHIPS = 999;

{ Definition of a SHIP.HST entry }
TYPE PShip=^TShip;
     TShip=RECORD
             Id:INTEGER;                {           x }
             Player:INTEGER;            {           x }
             FC:ARRAY[1..3] OF CHAR;    {           x }
             Speed:INTEGER;             {           x }
             Xwp,Ywp:INTEGER;           {           x }
             X,Y:INTEGER;               {           x }
             Engine:INTEGER;            {           x }
             Hull:INTEGER;              {           x }
             Beam:INTEGER;              {           x }
             BeamCnt:INTEGER;           {           x }
             FgtCnt:INTEGER;            {           x }
             Torp:INTEGER;              {           x }
             TorpCnt:INTEGER;           {           x }
             TorpLaun:INTEGER;          {           x }
             Mission:INTEGER;           {           x }
             Enemy:INTEGER;             {           x }
             TowId:INTEGER;             {           x }
             Damage:INTEGER;            {           x }
             Crew:INTEGER;              {           x }
             Colonist:INTEGER;          {           x }
             Name:ARRAY[1..20] OF CHAR; {           x }
             N,T,D,M:INTEGER;           {           x }
             Sup:INTEGER;               {           x }
             uN,uT,uD,uM,uC,uS,uDest:INTEGER; {     x }
             xN,xT,xD,xM,xC,xS,xDest:INTEGER; {     x }
             InterceptId:INTEGER;       {           x }
             Money:INTEGER;             {           x }
     END;

{ Definition of a HULLSPEC.DAT entry }
TYPE THull=RECORD
        Name:ARRAY[1..30] OF CHAR;
        Un1,Un2:INTEGER;
        Tritanium,Duranium,Molybdenium:INTEGER;
        Fuel:INTEGER;
        Crew:INTEGER;
        Engines:INTEGER;
        Mass:INTEGER;
        Tech:INTEGER;
        Cargo:INTEGER;
        Fight,Torps:INTEGER;
        Beam:INTEGER;
        Cost:INTEGER;
     END;

{ Item names }
CONST Engines:ARRAY[1..9] OF STRING[20]=
            ('StarDrive 1',
             'StarDrive 2',
             'StarDrive 3',
             'SuperStarDrive 4',
             'Nova Drive 5',
             'Heavy Nova Drive 6',
             'Quantam Drive 7',
             'Hyper Drive 8',
             'Transwarp Drive');

      Beams:ARRAY[1..10] OF STRING[20]=
            ('Laser',
             'X-Ray Laser',
             'Plasma Bolt',
             'Blaster',
             'Positron Beam',
             'Disruptor',
             'Heavy Blaster',
             'Phaser',
             'Heavy Disruptor',
             'Heavy Phaser');

      Torps:ARRAY[1..10] OF STRING[20]=
            ('Mark 1 Photon',
             'Proton Torpedo',
             'Mark 2 Photon',
             'Gamma Bomb',
             'Mark 3 Photon',
             'Mark 4 Photon',
             'Mark 5 Photon',
             'Mark 6 Photon',
             'Mark 7 Photon',
             'Mark 8 Photon');

{ Ability names }
CONST NumAbilityNames = 64;
      AbilityNames : ARRAY[0..NumAbilityNames-1] OF STRING[20] = (
             'Alchemy             ',
             'Refinery            ',
             'Advanced Refinery   ',
             'Heats to 50         ',
             'Cools to 50         ',
             'Heats to 100        ',
             'Hyperdrive          ',
             'Gravitonic          ',
             'Scans all Wormholes ',
             'Gambling            ',
             'Anti-cloak          ',
             'Imperial Assault    ',
             'Chunneling          ',
             'Ramscoop            ',
             'Advanced Bioscanner ',
             'Advanced Cloak      ',
             'Cloak               ',
             'Bioscanner          ',
             'Glory Device (10%)  ',
             'Glory Device (20%)  ',
             'Unclonable          ',
             'Clone Once          ',
             'Ungiveable          ',
             'Give Once           ',
             'Level 2 Tow         ',
             '25                  ',
             '26                  ',
             '27                  ',
             '28                  ',
             '29                  ',
             '30                  ',
             '31                  ',
             '32                  ',
             '33                  ',
             '34                  ',
             '35                  ',
             '36                  ',
             '37                  ',
             '38                  ',
             '39                  ',
             '40                  ',
             '41                  ',
             '42                  ',
             '43                  ',
             '44                  ',
             '45                  ',
             '46                  ',
             '47                  ',
             '48                  ',
             '49                  ',
             '50                  ',
             '51                  ',
             '52                  ',
             '53                  ',
             '54                  ',
             '55                  ',
             '56                  ',
             '57                  ',
             '58                  ',
             '59                  ',
             '60                  ',
             '61                  ',
             '62                  ',
             '63                  ');

TYPE TShipAbilityBitfield = ARRAY[0..1] OF LONGINT;
     TShipAbilityArray    = ARRAY[1..NUM_SHIPS] OF TShipAbilityBitfield;
     PShipAbilityBitfield = ^TShipAbilityBitfield;

     TWordArray = ARRAY[0..10000] OF WORD;
     PWordArray = ^TWordArray;

{ These are indexes counted in WORDs, not BYTEs }
CONST HULLFUNC_HDR_END = 56 DIV 2;
      HULLFUNC_COUNT_INDEX = 54 DIV 2;

VAR F:FILE;                               { generic file pointer }
    Hulls:ARRAY[1..105] OF THull;         { hullspec data }
    S:STRING;
    Ships:ARRAY[1..NUM_SHIPS] OF PShip;   { all ships. NIL if unknown }
    TS:TShip;
    i:INTEGER;
    R:WORD;
    GameDir,HostDir:STRING;
    j,k,l:INTEGER;
    Ch:CHAR;
    Total:INTEGER;

    Abilities    : ^TShipAbilityArray;    { ship ability data }
    AbilityCount : INTEGER;               { highest ship Id known }
    AbilityPos   : LONGINT;               { position in AUXDATA.HST } 

    Hullfunc     : PWordArray;            { hullfunc data }
    HullfuncSize : WORD;                  { size of hullfunc data, in WORDs }

CONST AbilitiesChanged : BOOLEAN = FALSE;

{ Standard input window. }
PROCEDURE GetInput(Title:STRING; VAR S:STRING);
VAR Ch:CHAR;
BEGIN
  Window(20,10,60,13);
  TextAttr:=$70;
  ClrScr;
  WriteLn;
  WriteLn('  ',Title);
  GotoXY(3,3);
  TextAttr:=$1F;
  Write(' ':37);
  S:='';
  REPEAT
    GotoXY(3,3);
    TextAttr:=$1F;
    Write(' ':37);
    GotoXY(3,3);
    Write(S);
    CursorOn;
    Ch:=Readkey;
    CursorOff;
    CASE Ch OF
      #8:IF S<>'' THEN Dec(S[0]);
      #32..#126,#128..#255:IF Length(S)<36 THEN S:=S+Ch;
      ^Y,#27:S:='';
    END;
  UNTIL (Ch=#13) OR (Ch=#27);
  Window(1,1,80,25);
END;

{ Ask user for a number. Returns TRUE if OK. }
FUNCTION QueryNumber(VAR CurMsg:INTEGER):BOOLEAN;
VAR Fn:STRING;
    Idx,i:INTEGER;
BEGIN
  QueryNumber:=FALSE;
  REPEAT
    GetInput('Go to ship ID#',Fn);
    IF Fn<>'' THEN BEGIN
      Val(Fn,Idx,I);
      IF (i<>0) OR (Idx<1) OR (Idx>NUM_SHIPS) OR (Ships[Idx]=NIL) THEN BEGIN
        Sound(1000);
        Delay(100);
        NoSound;
      END ELSE BEGIN
        Fn:='';
        CurMsg:=Idx;
        QueryNumber:=TRUE;
        Exit;
      END;
    END;
  UNTIL Fn='';
END;

{ Trim whitespace }
FUNCTION Strip(S:STRING):STRING;
BEGIN
  WHILE S[Length(S)]=' ' DO Dec(S[0]);
  Strip:=S;
END;

{ Complain about bogus hullfunc file, and free memory (pretend we don't
  have a hullfunc file) }
PROCEDURE BogusHullfunc(CONST s:STRING);
BEGIN
  Writeln('HULLFUNC.DAT is invalid: ', s, ' -- press any key.');
  IF HullfuncSize>0 THEN BEGIN
    FreeMem(Hullfunc, HullfuncSize*2);
    HullfuncSize:=0;
  END;
  REPEAT UNTIL Readkey<>#0;
END;

{ Load hullfunc information from F }
PROCEDURE LoadHullfunc(VAR F:FILE);
VAR size : LONGINT;
    i, j : INTEGER;
BEGIN
  size := FileSize(F);
  IF (Size > MAXINT) OR (Size < 48) THEN BEGIN
    { maximum size is around 13k }
    BogusHullFunc('Invalid size'); Exit;
  END;
  GetMem(Hullfunc, Size);
  Blockread(F, Hullfunc^, Size);
  HullfuncSize := Size DIV 2;

  { validate it }
  IF (Hullfunc^[0]<>$7f35) OR (Hullfunc^[1]<>$B129) THEN BEGIN BogusHullfunc('Invalid signature'); Exit; END;
  IF (Hullfunc^[HULLFUNC_COUNT_INDEX]<0) THEN BEGIN BogusHullfunc('Invalid hull count'); Exit; END;
  i := HULLFUNC_HDR_END;
  FOR j:=1 TO Hullfunc^[HULLFUNC_COUNT_INDEX] DO BEGIN
    IF (i>=HullfuncSize) OR (Hullfunc^[i+1]<=0) THEN BEGIN BogusHullfunc('Invalid hull record'); Exit; END;
    Inc(i, 2+2*Hullfunc^[i+1]);
  END;
  IF (i>=HullfuncSize) OR (Hullfunc^[i]<>$219A) OR (Hullfunc^[i+1]<>$1F0C) THEN BEGIN
    BogusHullfunc('File truncated'); Exit;
  END;
END;

{ Load ship-specific abilities from F }
PROCEDURE LoadAuxdata(VAR F:FILE);
VAR AuxHead : ARRAY[1..38] OF BYTE;
    R, cnt  : WORD;
    Chunk   : ARRAY[0..1] OF WORD;
BEGIN
  Blockread(F, AuxHead, Sizeof(AuxHead), R);
  IF R<>Sizeof(AuxHead) THEN Exit;
  IF AuxHead[1]<>4 THEN Exit;
  REPEAT
    BlockRead(F, Chunk, Sizeof(Chunk), R);
    IF R<>Sizeof(Chunk) THEN Exit;
    IF Chunk[0]=7 { Ship Special } THEN BEGIN
      cnt := Chunk[1] DIV 8;
      IF cnt > NUM_SHIPS THEN cnt := NUM_SHIPS;
      GetMem(Abilities, cnt*8);
      AbilityPos := FilePos(F);
      Blockread(F, Abilities^, cnt*8, R);
      IF R<>cnt*8 THEN BEGIN
        Writeln('AUXDATA.HST is invalid.');
        Halt;
      END;
      AbilityCount := cnt;
      Exit;
    END;
    Seek(F, FilePos(F) + Chunk[1]);
  UNTIL FALSE;
END;

{
  Ability editor
    ped   pointer to ship-specific abilities, NIL if none
    hf    hull functions
}
PROCEDURE EditAbilities(ped : PShipAbilityBitfield; CONST hf : TShipAbilityBitfield);
CONST sel : INTEGER = 0;
      top : INTEGER = 0;   { line number! }
      lines = 14;

  PROCEDURE XorLong(VAR l:LONGINT; v:LONGINT);
  BEGIN
    l := l XOR v;
  END;

VAR i, j, k:INTEGER;
    ch     :CHAR;
    ed     :TShipAbilityBitfield;
BEGIN
  IF (ped<>NIL) THEN ed := ped^ ELSE BEGIN ed[0]:=0; ed[1]:=0; END;
  Window(3, 5, 78, 23);
  TextAttr := $02;
  ClrScr;
  Write(' Edit Ship Abilities ');
  GotoXY(3, lines+4);
  IF ped<>NIL THEN Write('Use arrows to move, SPACE to toggle, C clears, RET saves, ESC cancels.')
              ELSE Write('Use arrows to move, ESC exits.');
  REPEAT
    WHILE sel < 0 DO Inc(sel, 2);
    WHILE sel >= NumAbilityNames DO Dec(sel, 2);
    IF sel < 2*top THEN top := sel DIV 2;
    IF sel >= 2*(top+lines-1) THEN top := (sel-2*lines+2) DIV 2;
    FOR i:=0 TO lines-1 DO BEGIN
      FOR j:=0 TO 1 DO BEGIN
        k := 2*(i+top)+j;
        GotoXY(35*j + 3, i+3);
        IF k=sel THEN TextAttr := $20 ELSE TextAttr := $02;
        IF (ed[k SHR 5] AND (LONGINT(1) SHL (k AND 31)))<>0
         THEN Write('[x] ')
         ELSE IF (hf[k SHR 5] AND (LONGINT(1) SHL (k AND 31)))<>0
         THEN BEGIN
           Write('[');
           IF k=sel THEN TextAttr := $28 ELSE TextAttr := $07;
           Write('x');
           IF k=sel THEN TextAttr := $20 ELSE TextAttr := $02;
           Write('] ');
         END ELSE Write('[ ] ');
        Write(AbilityNames[k]);
      END;
    END;
    CursorOn;
    GotoXY(35*(sel MOD 2) + 4, 3 + (sel DIV 2)-top);
    ch := Readkey;
    CursorOff;
    CASE ch OF
      #0: CASE Readkey OF
        #72: Dec(sel, 2);
        #75: sel := sel AND NOT 1;
        #77: sel := sel OR 1;
        #80: Inc(sel, 2);
        #71: sel:=0;
        #79: sel:=NumAbilityNames-1;
        #73: Dec(sel, 2*lines-2);
        #81: Inc(sel, 2*lines-2);
      END;
      ' ':IF ped<>NIL THEN XorLong(ed[sel SHR 5], (LONGINT(1) SHL (sel AND 31)));
      'C','c':IF ped<>NIL THEN BEGIN ed[0]:=0; ed[1]:=0; END;
      #27,#13:BEGIN
        IF (ch=#13) AND (ped<>NIL) THEN BEGIN ped^ := ed; AbilitiesChanged := TRUE; END;
        TextAttr := $1F;
        ClrScr;
        Window(1,1,80,25);
        Exit;
      END;
    END;
  UNTIL FALSE;
END;

{
  Figure out hull functions that apply to hull/pid and place them in hf
}
PROCEDURE QueryHullfunc(hull, pid : INTEGER; VAR hf : TShipAbilityBitfield);
VAR i, j, k, fun, mask : INTEGER;
BEGIN
  hf[0] := 0;
  hf[1] := 0;
  i := HULLFUNC_HDR_END;
  FOR j:=1 TO Hullfunc^[HULLFUNC_COUNT_INDEX] DO BEGIN
    IF hull=Hullfunc^[i] THEN BEGIN
      FOR k:=1 TO Hullfunc^[i+1] DO BEGIN
        fun := Hullfunc^[i+2*k];
        mask := Hullfunc^[i+2*k+1];
        IF (fun>=0) AND (fun<64) AND (mask AND (1 SHL pid)<>0) THEN
         hf[fun SHR 5] := hf[fun SHR 5] OR (LONGINT(1) SHL (fun AND 31));
      END;
    END;
    Inc(i, 2+2*Hullfunc^[i+1]);
  END;
END;

{ Read xxxSPEC.DAT file /fn/, and place the names in /data/ (which must be
  an array of STRING[20]). The file has /count/ records of /size/ bytes. }
PROCEDURE ReadSpec(CONST fn : STRING; VAR data; count, size : INTEGER);
VAR str : ARRAY[1..10] OF STRING[20] ABSOLUTE data;
    i,j : INTEGER;
    buf : RECORD
        name : ARRAY[1..20] OF CHAR;
        rest : ARRAY[1..100] OF BYTE;
    END;
    f : FILE;
BEGIN
  Assign(f, GameDir + fn);
  Reset(f, 1);
  IF IOResult<>0 THEN BEGIN
    Assign(f, HostDir + fn);
    Reset(f, 1);
    IF IOResult<>0 THEN Exit;
  END;
  FOR i:=1 TO count DO BEGIN
    Blockread(F, buf, size);
    str[i] := buf.name;
  END;
  Close(f);
END;

VAR hf : TShipAbilityBitfield;
BEGIN
  WriteLn(Copyrite);
  Write('Loading...'#13);
  Hostdir:=ParamStr(0);
  FileMode:=0;
  AbilityCount:=0;
  HullfuncSize:=0;
  WHILE HostDir[Length(HostDir)]<>'\' DO Dec(HostDir[0]);
  GameDir:=ParamStr(1);
  IF (GameDir<>'') AND NOT (GameDir[Length(GameDir)] IN [':','\']) THEN GameDir:=GameDir+'\';
  ReadSpec('ENGSPEC.DAT', Engines, 9, 66);
  ReadSpec('BEAMSPEC.DAT', Beams, 10, 36);
  ReadSpec('TORPSPEC.DAT', Torps, 10, 38);
  Assign(F,GameDir+'HULLSPEC.DAT');
  Reset(F,1);
  IF IOResult<>0 THEN BEGIN
    Assign(F,HostDir+'HULLSPEC.DAT');
    Reset(F,1);
    IF IOResult<>0 THEN BEGIN
      Writeln('Hull specifications (HULLSPEC.DAT) not found.');
      Halt;
    END;
  END;
  BlockRead(F,Hulls,SizeOf(Hulls));
  Close(F);
  FillChar(Ships,SizeOf(Ships),0);
  FOR i:=1 TO 11 DO BEGIN
    Str(i,S);
    Assign(F,GameDir+'SHIP'+S+'.DAT');
    Reset(F,1);
    IF IOResult=0 THEN BEGIN
      BlockRead(F,j,2);
      FOR k:=1 TO j DO BEGIN
        BlockRead(F,TS,SizeOf(TS));
        IF (TS.Id<=0) OR (TS.Id>NUM_SHIPS) THEN BEGIN
          Writeln('Ship Id ', TS.Id, ' out of allowed range.');
          Halt;
        END;
        IF Ships[TS.Id]<>NIL THEN BEGIN
          WriteLn('Data files mismatch.');
          Exit;
        END;
        New(Ships[TS.ID]);
        Ships[TS.ID]^:=TS;
      END;
      InOutRes:=0;
      Close(F);
    END;
  END;
  Assign(F,GameDir+'SHIP.HST');
  Reset(F,1);
  IF IOResult=0 THEN BEGIN
    Seek(F,2);
    FOR k:=1 TO NUM_SHIPS DO BEGIN
      BlockRead(F,TS,SizeOf(TS),R);
      IF R<>Sizeof(TS) THEN Break;
      IF TS.Player<>0 THEN BEGIN
        IF (TS.Id<=0) OR (TS.Id>NUM_SHIPS) THEN BEGIN
          Writeln('Ship Id ', TS.Id, ' out of allowed range.');
          Halt;
        END;
        IF (Ships[TS.Id]=NIL) THEN BEGIN
          New(Ships[TS.Id]);
          Ships[TS.ID]^:=TS;
        END;
      END;
    END;
    InOutRes:=0;
    Close(F);
    Assign(F,GameDir+'AUXDATA.HST');
    Reset(F,1);
    IF IOResult=0 THEN BEGIN
      LoadAuxdata(F);
      InOutRes:=0;
      Close(F);
    END;
  END;
  InOutRes:=0;
  Assign(F,GameDir+'HULLFUNC.DAT');
  Reset(F,1);
  IF IOResult=0 THEN BEGIN
    LoadHullfunc(F);
    InOutRes:=0;
    Close(F);
  END;
  i:=1;
  WHILE (i<=NUM_SHIPS) AND (Ships[i]=NIL) DO Inc(i);
  IF i>NUM_SHIPS THEN BEGIN
    WriteLn('No ships found.');
    Halt;
  END;
  InitCursor;
  Total:=0;
  FOR j:=1 TO NUM_SHIPS DO IF Ships[j]<>NIL THEN Inc(Total);
  TextAttr:=$1F;
  CursorOff;
  ClrScr;
  TextAttr:=$70;
  Write(' '+Copyrite);
  ClrEOL;
  GotoXY(1,25);
  ClrEOL;
  REPEAT
    TextAttr:=$1F;
    GotoXY(3,3);
    ClrEOL;
    WITH Ships[i]^ DO BEGIN
      Write('Ship ',i,': ',Strip(Name),' (',Strip(Hulls[Hull].Name),', Player ',Player,')');
      Window(3,5,37,11);
      TextAttr:=$02;
      ClrScr;
      Write(' Technical Info ');
      Write(' Engine: ',Engines[Engine]);
      IF Beam<>0 THEN Write(#13#10' Beams: ',BeamCnt,'x',Beams[Beam]);
      IF Torp<>0 THEN Write(#13#10' Torpedo: ',TorpLaun,'x',Torps[Torp]);
      IF FgtCnt<>0 THEN Write(#13#10' ',FgtCnt,' Fighter bay(s)');
      WriteLn;
      WriteLn(' Damage: ',Damage,'%');
      Write(' Crew: ',Crew,' of ',Hulls[Hull].Crew);
      IF (i<=AbilityCount) AND (Abilities^[i,0] OR Abilities^[i,1]<>0) THEN
       Write(#13#10' Has special abilities.')
      ELSE BEGIN
        QueryHullfunc(Hull, Player, hf);
        IF (hf[0] OR hf[1]<>0) THEN Write(#13#10' Has hull functions.');
      END;
      Window(40,5,78,11);
      ClrScr;
      Write(' Mission ');
      WriteLn(' Position: ',X,',',Y);
      WriteLn(' Target: ',X+Xwp,',',Y+Ywp,' (',Sqrt(LONGINT(Xwp)*Xwp+LONGINT(Ywp)*Ywp):1:2,' ly away)');
      WriteLn(' Speed: Warp ',Speed);
      WriteLn(' Friendly Code: ',fc);
      Write(' Mission: ');
      CASE Mission OF
        0:Write('none');
        1:Write('Explore');
        2:Write('Mine Sweep');
        3:Write('Lay Mines');
        4:Write('Kill');
        5:Write('Sensor Sweep');
        6:Write('Colonize');
        7:Write('Tow ship #',TowId);
        8:Write('Intercept ship #',InterceptId);
        9:CASE Player OF
          1:Write('Super Refit');
          2:Write('Hissssss!');
          3:Write('Super Spy');
          4:Write('Pillage Planet');
          5:Write('Rob Ship');
          6:Write('Self Repair');
          7:Write('Lay Web Mines');
          8:Write('Dark Sense');
          9,11:Write('Build fighters');
          10:Write('Rebel Ground Attack');
        END;
        10:Write('Cloak');
        11:Write('Beam up Fuel');
        12:Write('Beam up Duranium');
        13:Write('Beam up Tritanium');
        14:Write('Beam up Molybdenium');
        15:Write('Beam up Supplies');
      ELSE
        Write('Mission ', Mission);
        IF InterceptId<>0 THEN Write(' I=',InterceptId);
        IF TowId<>0 THEN Write(' T=',TowId);
      END;
      WriteLn;
      Write(' Primary Enemy: ',Enemy);
      Window(40,13,78,23);
      ClrScr;
      Write(' Cargo ');
      WriteLn('            aboard unload xfer');
      WriteLn(' Fuel:        ',N:4,uN:7,xN:5);
      WriteLn(' Tritanium:   ',T:4,uT:7,xT:5);
      WriteLn(' Duranium:    ',D:4,uD:7,xD:5);
      WriteLn(' Molybdenium: ',M:4,uM:7,xM:5);
      WriteLn(' Colonists:   ',Colonist:4,uC:7,xC:5);
      WriteLn(' Supplies:    ',Sup:4,uS:7,xS:5);
      WriteLn(' Money:      ',Money:5);
      WriteLn(' Torpedoes:   ',TorpCnt:4);
      Write(' To:                  ',uDest:3,xDest:5);
      Window(3,13,37,22);
      ClrScr;
      Write(' General ');
      WriteLn(' Total ships: ',Total);
      WriteLn;
      WriteLn(' -/+  Previous/next ship');
      Writeln(' '#27'/'#26'  Previous/next, same owner');
      WriteLn(' ESC  Exit');
      IF i<=AbilityCount THEN Writeln(' RET  Edit abilities') ELSE
      IF HullfuncSize>0 THEN  Writeln(' RET  Show abilities');
      Window(1,1,80,25);
    END;
    Ch:=Upcase(Readkey);
    IF Ch=#0 THEN CASE Readkey OF
      #80,#81:Ch:='+';
      #72,#73:Ch:='-';
      #75:BEGIN
        k:=Ships[i]^.Player;
        REPEAT
          Dec(i);
          IF i<1 THEN i:=NUM_SHIPS;
        UNTIL (Ships[i]<>NIL) AND (Ships[i]^.Player=k);
      END;
      #77:BEGIN
        k:=Ships[i]^.Player;
        REPEAT
          Inc(i);
          IF i>NUM_SHIPS THEN i:=1;
        UNTIL (Ships[i]<>NIL) AND (Ships[i]^.Player=k);
      END;
    END;
    CASE Ch OF
      '+':REPEAT
        Inc(i);
        IF i>NUM_SHIPS THEN i:=1;
      UNTIL Ships[i]<>NIL;
      '-':REPEAT
        Dec(i);
        IF i<1 THEN i:=NUM_SHIPS;
      UNTIL Ships[i]<>NIL;
      'G':BEGIN
        QueryNumber(i);
        Window(20,10,60,13);
        TextAttr:=$1F;
        ClrScr;
        Window(1,1,80,25);
      END;
      #13:BEGIN
        QueryHullfunc(Ships[i]^.Hull, Ships[i]^.Player, hf);
        IF i<=AbilityCount THEN EditAbilities(@Abilities^[i], hf) ELSE
        IF (hf[0] OR hf[1])<>0 THEN EditAbilities(NIL, hf);
      END;
    END;
  UNTIL Ch=#27;
  CursorOn;
  GotoXY(1,25);
  TextAttr:=7;
  ClrEOL;
  IF AbilitiesChanged AND (AbilityCount>0) THEN BEGIN
    Writeln('Saving changes to AUXDATA.HST...');
    FileMode:=2;
    Assign(F,GameDir+'AUXDATA.HST');
    Reset(F,1);
    Seek(F, AbilityPos);
    BlockWrite(F, Abilities^, 8*AbilityCount);
    Close(F);
    IF IOResult<>0 THEN Writeln('Error saving AUXDATA.HST, changes lost.');
  END;
END.
